#include <image.h>
#include <stdio.h>
#include <string.h>
#include <FindDirectory.h>
#include "gsdll.h"
#include <View.h>
#include <Rect.h>

extern "C" {
int (*_gsdll_revision)(char GSFAR * GSFAR * product, char GSFAR * GSFAR * copyright, long GSFAR * gs_revision, long GSFAR * gs_revisiondate);
int (*_gsdll_init)(GSDLL_CALLBACK callback, HWND hwnd, int argc, char GSFAR * GSFAR * argv);
int (*_gsdll_execute_begin)(void);
int (*_gsdll_execute_cont)(const char GSFAR * str, int len);
int (*_gsdll_execute_end)(void);
int (*_gsdll_exit)(void);
int (*_gsdll_lock_device)(unsigned char *device, int flag);
unsigned long (*_gsdll_get_bitmap)(unsigned char *device, unsigned char **pbitmap);
void (*_gsdll_draw)(unsigned char *device, BView *view, BRect dest, BRect src);
}

image_id libgs_image = 0;

status_t init_lib ()
{
	char libdir[B_FILE_NAME_LENGTH];
	find_directory (B_COMMON_LIB_DIRECTORY, 0, false, libdir, B_FILE_NAME_LENGTH);
	strcat (libdir, "/libgs.so");
	if (libgs_image < 0)
		return B_ERROR;
	if (libgs_image > 0)
		return B_OK;
		
	libgs_image = load_add_on (libdir);
	if (libgs_image <= 0)
	{
		// printf ("EPSTranslator: %s couldn't be loaded\n", libdir);
		return B_ERROR;
	}
	
	// printf ("Loaded %s\n", libdir);
	get_image_symbol (libgs_image, "gsdll_revision", B_SYMBOL_TYPE_TEXT, (void **) &_gsdll_revision);
	get_image_symbol (libgs_image, "gsdll_init", B_SYMBOL_TYPE_TEXT, (void **) &_gsdll_init);
	get_image_symbol (libgs_image, "gsdll_execute_begin", B_SYMBOL_TYPE_TEXT, (void **) &_gsdll_execute_begin);
	get_image_symbol (libgs_image, "gsdll_execute_cont", B_SYMBOL_TYPE_TEXT, (void **) &_gsdll_execute_cont);
	get_image_symbol (libgs_image, "gsdll_execute_end", B_SYMBOL_TYPE_TEXT, (void **) &_gsdll_execute_end);
	get_image_symbol (libgs_image, "gsdll_exit", B_SYMBOL_TYPE_TEXT, (void **) &_gsdll_exit);
	get_image_symbol (libgs_image, "gsdll_lock_device", B_SYMBOL_TYPE_TEXT, (void **) &_gsdll_lock_device);
	get_image_symbol (libgs_image, "gsdll_draw", B_SYMBOL_TYPE_TEXT, (void **) &_gsdll_draw);
	
	return B_OK;
}

extern "C" {
int GSDLLAPI s_gsdll_revision(char GSFAR * GSFAR * product, char GSFAR * GSFAR * copyright, long GSFAR * gs_revision, long GSFAR * gs_revisiondate);
int GSDLLAPI s_gsdll_init(GSDLL_CALLBACK callback, HWND hwnd, int argc, char GSFAR * GSFAR * argv);
int GSDLLAPI s_gsdll_execute_begin(void);
int GSDLLAPI s_gsdll_execute_cont(const char GSFAR * str, int len);
int GSDLLAPI s_gsdll_execute_end(void);
int GSDLLAPI s_gsdll_exit(void);
int GSDLLAPI s_gsdll_lock_device(unsigned char *device, int flag);
void s_gsdll_draw (unsigned char *device, BView *view, BRect dest, BRect src);
}

int GSDLLAPI s_gsdll_revision(char GSFAR * GSFAR * product, char GSFAR * GSFAR * copyright, long GSFAR * gs_revision, long GSFAR * gs_revisiondate)
{
	return _gsdll_revision (product, copyright, gs_revision, gs_revisiondate);
}

int GSDLLAPI s_gsdll_init(GSDLL_CALLBACK callback, HWND hwnd, int argc, char GSFAR * GSFAR * argv)
{
	return _gsdll_init (callback, hwnd, argc, argv);
}

int GSDLLAPI s_gsdll_execute_begin(void)
{
	return _gsdll_execute_begin ();
}

int GSDLLAPI s_gsdll_execute_cont(const char GSFAR * str, int len)
{
	return _gsdll_execute_cont (str, len);
}

int GSDLLAPI s_gsdll_execute_end(void)
{
	return _gsdll_execute_end();
}

int GSDLLAPI s_gsdll_exit(void)
{
	return _gsdll_exit();
}

int GSDLLAPI s_gsdll_lock_device(unsigned char *device, int flag)
{
	return _gsdll_lock_device (device, flag);
}

void s_gsdll_draw (unsigned char *device, BView *view, BRect dest, BRect src)
{
	return _gsdll_draw (device, view, dest, src);
}
