#include <translation/TranslationUtils.h>
#include <TranslatorRoster.h>
#include "BitmapView.h"
#include <BitmapStream.h>
#include <Bitmap.h>
#include <Message.h>
#include <Application.h>
#include <stdio.h>
#include <stdlib.h>

class MyApp : public BApplication
{
public:
			 MyApp (const char *sig) : BApplication (sig) {}
			~MyApp () {}
void		 SetBitmap (BBitmap *map) { fMap = map; };
virtual void ReadyToRun ()
			 {
			 	BWindow *win = new BWindow (BRect (100, 100, 300, 300), "ListViewTest", B_TITLED_WINDOW, 0, 0);
			 	BitmapView *view = new BitmapView (BRect (0, 0, 200, 200), "view", fMap);
			 	win->AddChild (view);
			 	win->Show();
			 }
private:
BBitmap		*fMap;
};

int main (int argc, char *argv[])
{
	MyApp app ("application/x-sum-pngtranstest");

	BMessage msg ('ioEX');
	BTranslatorRoster *roster = BTranslatorRoster::Default(); 

	msg.AddInt32 (B_TRANSLATOR_EXT_BITMAP_COLOR_SPACE, B_CMAP8);
	printf ("Getting Bitmap from %s\n", argv[1]);
	BFile in (argv[1], B_READ_ONLY);
	BBitmap *map;
	BBitmapStream inMap;
	roster->Translate (&in, NULL, &msg, &inMap, B_TRANSLATOR_BITMAP);
	msg.PrintToStream();
	inMap.DetachBitmap (&map);
	printf ("Color Space: %d\n", map->ColorSpace());
//	BBitmap *map = BTranslationUtils::GetBitmapFile (argv[1], &msg);
	BBitmapStream stream (map); // init with contents of bitmap 
    BFile file (argv[2], B_CREATE_FILE | B_WRITE_ONLY); 
    printf ("Writing to %s as PNG\n", argv[2]);
    roster->Translate (&stream, NULL, NULL, &file, 'PNG '); 
    
	app.SetBitmap (map);
	app.Run();
	
    delete roster;
	return 0;
}